﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.Runtime.InteropServices.ComTypes;
using System.Diagnostics;
using Excel = Microsoft.Office.Interop.Excel;
using Word = Microsoft.Office.Interop.Word;

namespace Test_EXCEL_OLE
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        [DllImport("ole32.dll")]
        static extern void CreateBindCtx(
            int reserved, out IBindCtx ppbc);

        [DllImport("ole32.dll")]
        static extern void GetRunningObjectTable(
            int reserved,
            out IRunningObjectTable prot);

        static Guid guid_unkown = new Guid("00000000-0000-0000-C000-000000000046");

        void use_getobject(bool isExcel)
        {
            object ob = null;
            if (isExcel)
            {
                Process[] ps = Process.GetProcessesByName("Excel");

                if (ps.Length == 0)
                {
                    throw new Exception("エクセルを起動してください");
                }

                try
                {
                    ob = Microsoft.VisualBasic.Interaction.GetObject(null, "Excel.Application")
                as Microsoft.Office.Interop.Excel.Application;
                }
                catch
                {
                    ob = null;
                }
            }
            else
            {
                Process[] ps = Process.GetProcessesByName("WinWord");
                if (ps.Length == 0)
                {
                    throw new Exception("ワードを起動してください");
                }

                try
                {
                    ob = Microsoft.VisualBasic.Interaction.GetObject(null, "Word.Application")
                as Microsoft.Office.Interop.Word.Application;
                }
                catch
                {
                    ob = null;
                }
            }

            if (ob == null)
            {
                richTextBox1.AppendText("getobject 失敗\n");
            }
            else
            {
                richTextBox1.AppendText("getobject　成功\n");
            }


            if (ob != null) { Marshal.ReleaseComObject(ob); ob = null; }
        }

        void use_BindToObject_from_table(bool isExcel)
        {
            richTextBox1.AppendText("テーブルを検索しています....\n");

            object ob = null;

            IBindCtx ctx = null;
            CreateBindCtx(0, out ctx);

            IRunningObjectTable table = null;
            ctx.GetRunningObjectTable(out table);

            IEnumMoniker e_moniker = null;
            table.EnumRunning(out e_moniker);

            e_moniker.Reset();

            IMoniker[] monikers = { null };
            IntPtr ptr = IntPtr.Zero;

            while (e_moniker.Next(1, monikers, ptr) == 0)
            {
                string str;
                monikers[0].GetDisplayName(ctx, null, out str);
                richTextBox1.AppendText("Display名 :" + str + "\n");

                object temp = null;
                try
                {
                    monikers[0].BindToObject(ctx, null, ref guid_unkown, out temp);

                    if (isExcel)
                    {
                        ob = temp as Excel.Workbook;
                        if (ob != null)
                        {
                            break;
                        }
                    }
                    else
                    {
                        ob = temp as Word.Document;
                        if (ob != null)
                        {
                            break;
                        }
                    }
                }
                catch
                {

                }
                finally
                {
                    Marshal.ReleaseComObject(monikers[0]);
                }

                monikers[0] = null;
                ptr = IntPtr.Zero;
            }

            Marshal.ReleaseComObject(e_moniker);
            Marshal.ReleaseComObject(table);
            Marshal.ReleaseComObject(ctx);

            if (ob == null)
            {
                richTextBox1.AppendText("BindToObject 失敗\n");
            }
            else
            {
                richTextBox1.AppendText("BindToObject　成功\n");
            }

            if (ob != null) { Marshal.ReleaseComObject(ob); ob = null; }
        }

        private void btn_open_Excel_Click(object sender, EventArgs e)
        {
            try
            {
                use_getobject(true);
                use_BindToObject_from_table(true);
            }
            catch (Exception exc)
            {
                MessageBox.Show(exc.Message);
            }
        }

        private void btn_open_word_Click(object sender, EventArgs e)
        {
            try
            {
                use_getobject(false);
                use_BindToObject_from_table(false);
            }
            catch (Exception exc)
            {
                MessageBox.Show(exc.Message);
            }            
        }
    }
}
